type node = (int * char option)
type 'a btree = 'a BinTree.t = Empty | Node of ('a btree * 'a * 'a btree)
type t = node btree
type bits = int list
type freq = (char * int)Lst.t
type table = (char * bits)Lst.t

val collate : Strng.t -> freq
val combine : t list -> t list
val compress : string -> string -> unit
val decode : t -> bits -> Strng.t
val encode : table -> Strng.t -> bits
val expand : string -> string -> unit
val lookup : table -> char -> bits
val mknode : (char * int) -> t
val sample : Strng.t -> freq
val table : t -> table
val toplevel_printer : Format.formatter -> t -> unit
val toplevel_printer_bits : Format.formatter -> bits -> unit
val toplevel_printer_freq : Format.formatter -> freq -> unit
val toplevel_printer_node : Format.formatter -> node -> unit
val toplevel_printer_table : Format.formatter -> table -> unit
val tree : freq -> t
